package rechnernetze;

import java.net.Socket;
import java.net.ServerSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.net.UnknownHostException;

import java.io.IOException;
import java.io.BufferedReader;

import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;


public class Server_2 implements Runnable {
  Socket socket;

  public Server_2(Socket socket) {
    System.out.println("Server gestartet.");
    this.socket = socket;
  }


  public static void warten_auf_client(int port) {
    System.out.println("Starte Server.");
    ServerSocket serversocket;
    try {
      serversocket = new ServerSocket(port);

      while (true) {
        Socket socket = serversocket.accept();
        socket.setReceiveBufferSize(1500);
        socket.setSoTimeout(60*1000);          
        System.out.println("Verbindung!");
        Server_2 server = new Server_2(socket);
        Thread thread = new Thread(server);
        thread.start();
      }
    } catch (IOException e) {System.err.println("####### Server-Fehler #######");}
  }

  public void run() {
    while (empfangePackete()) {
    }

    try {
      socket.close();
    } catch (IOException e) {};
  }

  /** Empfaengt TCP-Pakete. */
  private boolean empfangePackete() {
     try {
       try {
        // auf Clients warten
        // Verbindungsdaten merken
        InetAddress clientAdresse = socket.getInetAddress();
        int clientPort = socket.getPort();

        // Daten empfangen
        InputStream is = socket.getInputStream();
        InputStreamReader isr = new InputStreamReader(is);
        BufferedReader br = new BufferedReader(isr);
        String packet = br.readLine();

        // Wadde hadde dude da?
        System.out.println("Schnueffeln - Wadde hadde dudde da? : ");
        System.out.println("Client Adresse : " + clientAdresse.getHostAddress());
        System.out.println("Client Port    : " + clientPort);
        System.out.println(packet);

        // Daten zurueck schicken
        System.out.println("Oeffne TCP-Verbindung zu Client.");
        OutputStream os = socket.getOutputStream();
        OutputStreamWriter osw = new OutputStreamWriter(os);
        PrintWriter pw = new PrintWriter(osw);
        pw.println(packet);
        pw.flush();

        System.out.println("Paket zurueckgeschickt.");
      } catch (java.io.InterruptedIOException e) {
        System.out.println("TimeOut - Schliesse Server.");
        return false;
      }
    } catch (IOException e) {}

    return true;
  }

  public static void main(String[] args) {
    System.out.println("Server [port].");
    System.out.println("--------------");
    Server_2.warten_auf_client(Integer.parseInt(args[0]));
//    server.invokedStandalone = true;
  }
  private boolean invokedStandalone = false;
}